const app = getApp<IAppOption>();

// pages/story/a.ts
Component({
  /**
   * 组件的属性列表
   */
  externalClasses: [],
  properties: {
    src: {
      type: String,
      optionalTypes: [String, Number],
      value: "",
    },
    level: {
      type: Number,
      optionalTypes: [String, Number],
      value: 1,
    },
    did: {
      type: String,
      optionalTypes: [String, Number],
      value: "",
    },
    type: {
      type: String,
      optionalTypes: [String],
      value: "",
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    showDetail: false,
    popupDoctorDetail: {},
    DoctorTitleType: {},
    hospitalClassification: {},
    hospitalLevel: {},
  },

  /**
   * 组件的方法列表
   */
  methods: {
    async getDoctorDict(): Promise<any> {
      return wx.ajax({
        method: "GET",
        url: "?r=takeda/reg/doctor-dict",
        data: {},
      });
    },
    async handleDetail() {
      const { did, popupDoctorDetail, showDetail, type } = this.data;
      if (type) {
        app.mpBehavior({ PageName: type });
      }
      if (!did || showDetail) return;
      this.setData({
        showDetail: true,
      });
      if (Object.keys(popupDoctorDetail).length) return;
      const { DoctorTitleType } = await this.getDoctorDict();
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/detail",
        data: {
          DoctorId: did,
        },
      }).then((res) => {
        this.setData({
          popupDoctorDetail: {
            DoctorLevel: res.DoctorLevel,
            DoctorImg: res.Img,
            DoctorName: res.Name,
            DoctorTitleName: res.TitleType === "99" ? res.OtherTitle : DoctorTitleType[res.TitleType],
            HospitalName: res.HospitalName,
            HospitalClassificationName: res.HospitalClassificationName,
            HospitalLevelName: res.HospitalLevelName,
            CityName: res.CityName,
            CountyName: res.CountyName,
            Introduce: res.Introduce,
            department: res.Department,
            specialty: res.Specialty,
          },
        });
      });
    },
    handlePopupClose() {
      this.setData({
        showDetail: false,
      });
    },
  },
});

export {};
