const app = getApp<IAppOption>();

// pages/story/a.ts
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    userInfo: Object,
    DoctorTitleType: Object,
    hospitalClassification: Object,
    hospitalLevel: Object,
    did: String,
  },

  /**
   * 组件的初始数据
   */
  data: {
    take: {},
    case: {} as any,
    cooperateList: [],
    inviteList: [],
    newCaseShow: false,
  },

  lifetimes: {
    attached() {
      this.getTake();
      this.getCase();
    },
  },
  /**
   * 组件的方法列表
   */
  methods: {
    getTake() {
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/todo",
        data: {
          DoctorId: this.data.did,
        },
      }).then((res) => {
        this.setData({
          take: res,
        });
      });
    },
    getCase() {
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/case",
        data: {
          DoctorId: this.data.did,
        },
      }).then((res) => {
        this.setData({
          case: res,
        });
      });
    },
    handleQuestion(e) {
      const { index } = e.currentTarget.dataset;
      this.triggerEvent("question", index);
    },

    handleNewCase() {
      this.setData({
        newCaseShow: true,
      });
    },
    handleNewCaseClose() {
      this.setData({
        newCaseShow: false,
      });
    },
  },
});

export {};
