import dayjs from "dayjs";
const app = getApp<IAppOption>();

const echarts = require("../ec-canvas/echarts.js");

// pages/story/a.ts
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    userInfo: Object,
    DoctorTitleType: Object,
    hospitalClassification: Object,
    hospitalLevel: Object,
    did: String,
  },

  /**
   * 组件的初始数据
   */
  data: {
    take: {},
    case: {} as any,
    doctorCount: {},

    DepartmentId: "",
    DepartmentName: "",

    newCaseShow: false,

    tips: {},
  },

  lifetimes: {
    attached() {
      const { DepartmentId, DepartmentName } = this.data.userInfo.Department[0];
      this.setData({
        Department: this.data.userInfo.Department,
        DepartmentId,
        DepartmentName,
      });
      this.getTake();
      this.getCase();
      this.getManageDoctor();
      this.getTips();
    },
  },
  /**
   * 组件的方法列表
   */
  methods: {
    getTake() {
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/todo",
        data: {
          DoctorId: this.data.did,
        },
      }).then((res) => {
        this.setData({
          take: res,
        });
      });
    },
    handleChangeDept(e) {
      const index = e.detail.value;
      const { DepartmentId, DepartmentName } = this.data.userInfo.Department[index];
      this.setData({
        DepartmentId,
        DepartmentName,
      });
      this.getCase();
      this.getManageDoctor();
    },
    getCase() {
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/case",
        data: {
          DepartmentId: this.data.DepartmentId,
          DoctorId: this.data.did,
        },
      }).then((res) => {
        this.setData({
          case: res,
        });
      });
    },
    getManageDoctor() {
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/manage-doctor-count",
        data: { DepartmentId: this.data.DepartmentId, DoctorId: this.data.did },
      }).then((res) => {
        this.setData({
          doctorCount: res.count,
        });
      });
    },
    handleQuestion(e) {
      const { index } = e.currentTarget.dataset;
      this.triggerEvent("question", index);
    },
    handleNewCase() {
      this.setData({
        newCaseShow: true,
      });
    },
    handleNewCaseClose() {
      this.setData({
        newCaseShow: false,
      });
    },
    getTips() {
      wx.ajax({
        method: "GET",
        url: "?r=takeda/doctor/get-tips",
        data: {},
      }).then((res) => {
        this.setData({
          tips: res,
        });
      });
    },
  },
});

export {};
