const app = getApp<IAppOption>();

Page({
  data: {
    feedbackTimeBegin: "",
    feedbackTimeEnd: "",

    status: [
      {
        id: "",
        value: "全部",
      },
      {
        id: "0",
        value: "待审核",
      },
      {
        id: "1",
        value: "审核通过",
      },
      {
        id: "2",
        value: "审核驳回",
      },
    ],
    statusNames: {
      0: "待审核",
      1: "审核通过",
      2: "审核驳回",
    },
    auditStatus: "",

    list: [],
    pagination: {
      page: 1,
      pages: 1,
      count: 1,
    },
  },
  onLoad() {
    app.waitLogin().then(() => {
      app.mpBehavior({ PageName: "PG_DOCTORBINDRECORD" });
      this.getList();
    });
  },
  handleStatus(e) {
    this.setData({
      auditStatus: e.detail.value === 0 ? "" : String(e.detail.value - 1),
    });
    this.getList();
  },
  onClose() {
    this.setData({
      auditStatus: "",
    });
    this.getList();
  },
  getList(newPage = 1) {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/doctor/apply-list",
      data: {
        page: newPage,
        auditStatus: this.data.auditStatus || -1,
      },
    }).then((res) => {
      const list = res.page === 1 ? res.list : [...this.data.list, ...res.list];
      this.setData({
        list,
        pagination: {
          page: res.page,
          pages: res.pages,
          count: res.count,
        },
      });
    });
  },
  onReachBottom() {
    const { page, pages } = this.data.pagination;
    if (pages > page) {
      this.getList(page + 1);
    }
  },
});

export {};
