const app = getApp<IAppOption>();

Page({
  data: {
    show: false,
    showReject: false,
    showResolve: false,
    id: "",

    userInfo: {},
    detail: {} as any,

    RejectReason: "",

    DoctorTitleType: {},
  },
  onLoad(options) {
    this.setData({
      id: options.id,
      onBeforeReject: (e) => {
        if (e === "confirm") {
          if (!this.data.RejectReason && e === "confirm") {
            wx.showToast({
              title: "请填写驳回原因",
              icon: "none",
            });
            return false;
          }
          this.onConfirmReject();
        }

        return true;
      },
    });

    app.waitLogin().then(() => {
      this.getDoctorDict();
      this.getDetail();
      app.getUserInfo(this);
    });
  },
  getDoctorDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/doctor-dict",
      data: {},
    }).then((res) => {
      this.setData({
        DoctorTitleType: res.DoctorTitleType,
      });
    });
  },
  getDetail() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/doctor/audit-detail",
      data: {
        AuditId: this.data.id,
      },
    }).then((res) => {
      this.setData({
        detail: {
          ...res,
        },
      });
    });
  },
  handleReject() {
    app.mpBehavior({ PageName: "BTN_DOCTORREJECT" });
    this.setData({
      showReject: true,
    });
  },
  handleAddReject(e: any) {
    const { value } = e.currentTarget.dataset;
    this.setData({
      RejectReason: this.data.RejectReason + value,
    });
  },
  onConfirmReject() {
    const { RejectReason, detail } = this.data;
    wx.ajax({
      method: "POST",
      url: "?r=takeda/doctor/audit-reject",
      data: {
        AuditId: detail.AuditId,
        RejectReason,
      },
    }).then(() => {
      wx.navigateBack();
    });
  },
  handleResolve() {
    app.mpBehavior({ PageName: "BTN_DOCTORAPPROVE" });
    this.setData({
      show: true,
    });
  },
  handleSubmit() {
    const { detail } = this.data;
    this.setData({
      show: false,
    });
    wx.ajax({
      method: "POST",
      url: "?r=takeda/doctor/audit-pass",
      data: {
        AuditId: detail.AuditId,
        InviteDoctorId: 0,
      },
    }).then(() => {
      wx.navigateBack();
    });
  },
  handleSetDoctor() {
    const { detail } = this.data;
    this.setData({
      show: false,
    });
    wx.redirectTo({
      url: `/module1/pages/setDoctor/index?id=${detail.AuditId}`,
    });
  },
  handleDialogClose() {
    this.setData({
      show: false,
    });
  },
  handlePreview(e: any) {
    const { url } = e.currentTarget.dataset;
    wx.previewImage({
      urls: [url],
    });
  },
});

export {};
