const app = getApp<IAppOption>();

Page({
  data: {
    hospitalClassification: {},
    hospitalLevel: {},
    applyHostipal: null,

    showArea: false,
    area: [],
    fieldNames: { text: "label", value: "value", children: "children" },

    ProvinceName: "",
    CityName: "",
    CountyName: "",

    AuditId: 0,
    Name: "",
    ShortName: "",
    ProvinceId: "",
    CityId: "",
    CountyId: "",
    Address: "",
    HospitalClassification: "",
    HospitalLevel: "",
  },
  onLoad() {
    app.waitLogin(true).then(() => {
      this.getHospitalDict();
      this.getArea();
      this.getApplyHostipal();
    });
  },
  getApplyHostipal() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/last-apply-hospital",
      data: {},
    }).then((res) => {
      if (!Array.isArray(res) && res.AuditStatus !== 1) {
        this.setData({
          applyHostipal: res,

          AuditId: res.AuditId,

          Name: res.Name,
          ShortName: res.ShortName,
          ProvinceId: res.ProvinceId,
          CityId: res.CityId,
          CountyId: res.CountyId,
          Address: res.Address,
          HospitalClassification: `${res.HospitalClassification}`,
          HospitalLevel: `${res.HospitalLevel}`,

          ProvinceName: res.ProvinceName,
          CityName: res.CityName,
          CountyName: res.CountyName,
        });
      }
    });
  },
  getHospitalDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/hospital-dict",
      data: {},
    }).then((res) => {
      this.setData({
        hospitalClassification: res.hospitalClassification,
        hospitalLevel: res.hospitalLevel,
      });
    });
  },
  getArea() {
    wx.ajax({
      method: "GET",
      url: "/js/area.json",
      isJSON: true,
    }).then((res) => {
      this.setData({
        area: res,
      });
    });
  },

  handleArea() {
    this.setData({
      showArea: true,
    });
  },
  onClose() {
    this.setData({
      showArea: false,
    });
  },
  onFinish(e: any) {
    this.setData({
      ProvinceId: e.detail.code[0],
      ProvinceName: e.detail.value[0],
      CityId: e.detail.code[1],
      CityName: e.detail.value[1],
      CountyId: e.detail.code[2],
      CountyName: e.detail.value[2],
      showArea: false,
    });
  },
  handleSelect(e) {
    const { value, key } = e.currentTarget.dataset;
    this.setData({
      [key]: value,
    });
  },
  handleSubmit() {
    const { AuditId, Name, ShortName, ProvinceId, CityId, CountyId, Address, HospitalClassification, HospitalLevel } =
      this.data;
    if (!Name) {
      wx.showToast({
        title: "请输入医院名称",
        icon: "none",
      });
      return;
    }
    if (!ProvinceId) {
      wx.showToast({
        title: "请选择城市地区",
        icon: "none",
      });
      return;
    }
    wx.ajax({
      method: "POST",
      url: "?r=takeda/reg/apply-hospital",
      data: {
        AuditId,
        Name,
        ShortName,
        ProvinceId,
        CityId,
        CountyId,
        Address,
        HospitalClassification,
        HospitalLevel,
      },
    }).then((res) => {
      wx.redirectTo({
        url: `/module1/pages/cHostipalResult/index?isf=${res.isFollow}`,
      });
    });
  },
  handleCancel() {
    wx.navigateBack();
  },
});

export {};
