const app = getApp<IAppOption>();

Page({
  data: { id: "", caseId: "", list: [], canInvite: false },
  onLoad(options) {
    this.setData({ id: options.id, caseId: options.cid });
  },
  onShow() {
    app.waitLogin().then(() => {
      this.getInvite();
      this.getDetail();
    });
  },
  getInvite() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/chat/get-invite-doctor-list",
      data: { count: 1, caseId: this.data.caseId },
    }).then((res) => {
      this.setData({
        canInvite: res.canInvite === 1,
      });
    });
  },
  getDetail() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/chat/get-room-doctor",
      data: {
        roomId: this.data.id,
      },
    }).then((res) => {
      this.setData({
        list: res,
      });
    });
  },
  handleDoctor() {
    wx.navigateTo({
      url: `/module1/pages/setChatDoctor/index?rid=${this.data.id}&cid=${this.data.caseId}`,
    });
  },
});

export {};
