const app = getApp<IAppOption>();
export {};

Page({
  data: {
    level: 0,

    hide: true,

    show1: false,
    bindDoctorName: "",

    id: "",
    userInfo: {},
    DoctorTitleType: {},

    hospitalClassification: {},
    hospitalLevel: {},
  },
  onLoad(options) {
    app.waitLogin().then(() => {
      this.getDoctorDict();
      this.getHostipalDict();
      this.getDoctorDetail(options.id, (res) => {
        this.setData({
          id: options.id,
          level: res.IsSuper === 1 ? 4 : res.DoctorLevel,
          userInfo: res,
        });
      });
    });
  },
  onShow() {
    this.setData({
      hide: false,
    });
  },
  onHide() {
    this.setData({
      hide: true,
    });
  },
  getDoctorDetail(id, callback) {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/doctor/detail",
      data: {
        DoctorId: id,
      },
    }).then((res) => {
      callback(res);
    });
  },
  getDoctorDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/doctor-dict",
      data: {},
    }).then((res) => {
      this.setData({
        DoctorTitleType: res.DoctorTitleType,
      });
    });
  },
  getHostipalDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/hospital-dict",
      data: {},
    }).then((res) => {
      this.setData({
        hospitalClassification: res.hospitalClassification,
        hospitalLevel: res.hospitalLevel,
      });
    });
  },

  handleQuestion(e) {
    const index = e.detail;
    const tip = {
      1: "无任何医生反馈、以及操作的病历",
      2: "有医生反馈且未归档的病历",
      3: "设为归档的病历，病历参与者不可反馈，仅可访问",
      4: "科室医生入驻情况：按月统计所在科室注册平台的医生数，并以堆叠图显示一级医生、二级医生、三级医生数;其中，一级医生为全平台的一级医生，不区分科室",
      5: "累计病历统计：按月统计所在科室累计提交的病历数，并以堆叠图显示一级医生、核心医生提交病历数",
      6: "科室新增病历统计：按月统计所在科室新提交的病历 数，并以堆叠图显示一级医生、核心医生提交的病历数",
      7: "医院活跃排行榜：按医院入驻医生数进行活跃排序，入驻医生数越多则活跃度越高，排序则越靠前",
    }[index];
    wx.showModal({
      content: tip,
      confirmColor: "#00B4C5",
      cancelColor: "#141515",
      showCancel: false,
    });
  },
});
