const app = getApp<IAppOption>();

Page({
  data: {
    list: [],
    pagination: {
      page: 1,
      pages: 1,
      count: 1,
    },
  },
  onLoad() {
    app.waitLogin().then(() => {
      this.getList();
    });
  },
  getList(newPage = 1) {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/stat/hospital-doctor-rank-list",
      data: {
        page: newPage,
        count: 20,
      },
    }).then((res) => {
      const list = res.page === 1 ? res.list : [...this.data.list, ...res.list];
      this.setData({
        list,
        pagination: {
          page: res.page,
          pages: res.pages,
          count: res.count,
        },
      });
    });
  },
  onReachBottom() {
    const { page, pages } = this.data.pagination;
    if (pages > page) {
      this.getList(page + 1);
    }
  },
  handleQuestion(e) {
    const index = e.detail;
    const tip = {
      0: "一级医生",
      1: "核心医生",
      2: "质控医生",
    }[index];
    wx.showModal({
      content: tip,
      confirmColor: "#00B4C5",
      cancelColor: "#141515",
      showCancel: false,
    });
  },
});

export {};
