const app = getApp<IAppOption>();

Page({
  data: {
    menuButtonInfo: {},
    userInfo: {},
    DoctorTitleType: {},
    codeUrl: "",
  },
  onLoad() {
    app.waitLogin().then(() => {
      app.getUserInfo(this);
      this.getDoctorDict();
      const { url, loginState } = app.globalData;
      this.setData({
        codeUrl: `${url}?r=takeda/account/mp-info&loginState=${loginState}`,
      });
    });
  },
  getDoctorDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/doctor-dict",
      data: {},
    }).then((res) => {
      this.setData({
        DoctorTitleType: res.DoctorTitleType,
      });
    });
  },
  handleSave() {
    const { codeUrl } = this.data;
    wx.downloadFile({
      url: codeUrl,
      success: (res) => {
        wx.showShareImageMenu({
          path: res.tempFilePath,
        });
      },
    });
  },
  handleShare() {
    wx.showToast({
      icon: "none",
      title: "请长按图片转发给好友",
    });
  },
  handleBack() {
    wx.navigateBack();
  },
});

export {};
