const app = getApp<IAppOption>();

Page({
  data: {
    show1: false,
    show2: false,

    userInfo: {},
    DepartmentName: "",

    deptList: [] as any,
    labelList: [] as any,

    Img: "",
    Name: "",
    DepartmentId: [] as any,
    SpecialtyId: [] as any,
    Introduce: "",
  },
  onShow() {
    app.waitLogin().then(async () => {
      app.mpBehavior({ PageName: "PG_PERSONALINFO" });
      await this.getDoctorDict();
      this.getUserInfo();
    });
  },
  getUserInfo() {
    app.getUserInfo(this, (userInfo) => {
      userInfo.encryptionTel = userInfo.Telephone.replace(/(\d{3})\d{4}(\d{4})/, "$1****$2");
      const labelList: any = [];
      this.data.deptList.forEach((item) => {
        if (userInfo.DepartmentId.includes(item.value)) {
          labelList.push(...item.options);
        }
      });
      this.setData({
        userInfo,
        Img: userInfo.Img,
        Name: userInfo.Name,
        Introduce: userInfo.Introduce,
        DepartmentId: userInfo.DepartmentId,
        SpecialtyId: userInfo.SpecialtyId,
        DepartmentName: userInfo.Department.reduce((pre, cur) => {
          return `${pre}${pre ? "," : ""}${cur.DepartmentName}`;
        }, ""),
        SpecialtyName: userInfo.Specialty.reduce((pre, cur) => {
          return `${pre}${pre ? "," : ""}${cur.SpecialtyName}`;
        }, ""),
        labelList,
      });
    });
  },
  getDoctorDict() {
    return wx
      .ajax({
        method: "GET",
        url: "?r=takeda/reg/doctor-dict",
        data: {},
      })
      .then((res) => {
        this.setData({
          deptList: res.DoctorSpecialtyLabel,
        });
      });
  },
  handleFile(e) {
    this.setData({
      Img: e.detail.imgUrl,
    });
    this.handleSubmit();
  },
  handleShowDept() {
    app.mpBehavior({ PageName: "BTN_PERSONALINFODEPARTMENT" });
    this.setData({
      show1: true,
    });
  },
  handleDept(e) {
    const { params } = e.currentTarget.dataset;
    const DepartmentId = this.data.DepartmentId;
    const newDeptId: any = DepartmentId.includes(params.value)
      ? DepartmentId.filter((item) => item !== params.value)
      : [...DepartmentId, params.value];
    const newDeptName = this.data.deptList
      .filter((item) => newDeptId.includes(item.value))
      .map((item) => item.label)
      .join(",");
    const labelList = this.data.deptList
      .filter((item) => newDeptId.includes(item.value))
      .reduce((pre, cur) => {
        return [...pre, ...cur.options];
      }, []);
    this.setData({
      DepartmentId: newDeptId,
      deptName: newDeptName || "全部",
      labelList,
      SpecialtyId: [],
    });
  },
  handleLabel(e) {
    const { params } = e.currentTarget.dataset;
    const { SpecialtyId, labelList } = this.data;
    const newLabelId = SpecialtyId.includes(params.value)
      ? SpecialtyId.filter((item) => item !== params.value)
      : [...SpecialtyId, params.value];
    let labelName = "";
    labelList.forEach((item) => {
      if (newLabelId.includes(item.value)) {
        labelName = `${labelName}${labelName ? "," : ""}${item.label}`;
      }
    });

    this.setData({
      SpecialtyId: newLabelId,
      labelName: labelName || "全部",
    });
  },
  handleIntroduce() {
    app.mpBehavior({ PageName: "BTN_PERSONALINFOINTRODUCTION" });
    this.setData({
      show2: true,
    });
  },
  onClose() {
    this.setData({
      show1: false,
      show2: false,
    });
    this.getUserInfo();
  },
  handleSubmit() {
    const { Img, Name, Introduce, DepartmentId, SpecialtyId } = this.data;
    if (DepartmentId.length && !SpecialtyId.length) {
      wx.showToast({
        title: "请选择标签",
        icon: "none",
      });
      return;
    }
    wx.ajax({
      method: "POST",
      url: "?r=takeda/doctor/update-info",
      data: {
        Img,
        Name,
        Introduce,
        DepartmentId,
        SpecialtyId,
      },
    }).then(() => {
      this.getUserInfo();
    });
    this.onClose();
  },
  changePhone() {
    app.mpBehavior({ PageName: "BTN_PERSONALINFOCHANGEMOBILE" });
    wx.navigateTo({
      url: "/module1/pages/changePhone/index",
    });
  },
  handleBrief() {
    this.setData({
      popupBriefShow: true,
    });
  },
  handleLoginOut() {
    app.mpBehavior({ PageName: "BTN_PERSONALINFOLOGOUT" });
    wx.showModal({
      confirmColor: "#00B4C5",
      cancelColor: "#141515",
      title: "确认退出登录？",
      success(res) {
        if (res.confirm) {
          app.globalData.isLogin = 0;
          wx.ajax({
            method: "POST",
            url: "?r=takeda/account/reg-logout",
          }).then(() => {
            wx.reLaunch({
              url: "/module1/pages/login/index",
            });
          });
        }
      },
    });
  },
  handleLogout() {
    app.mpBehavior({ PageName: "BTN_PERSONALINFOCANCELACCOUNT" });
    wx.navigateTo({
      url: "/module1/pages/loginOut/index",
    });
  },
});

export {};
