const app = getApp<IAppOption>();

Page({
  data: {
    fold: true,

    show1: false,
    show2: false,
    show3: false,
    showArea: false,
    fieldNames: { text: 'label', value: 'value', children: 'children' },

    nav: '0',

    area: [],
    caseStatusList: {},
    fileTypeList: {},
    reasonList: {},

    pagination: {
      page: 1,
      pages: 1,
      count: 1,
    },
    list: [],

    hostilatSearch: '',
    hostipalList: [],
    hospitalClassification: {},
    hospitalLevel: {},
    hostipalPagination: {
      page: 1,
      pages: 1,
      count: 1,
    },

    deptList: [] as any,
    labelList: [] as any,

    caseStatusName: '全部',
    hospitalName: '全部',
    deptName: '全部',
    labelName: '全部',
    provinceName: '',
    cityName: '',
    countyName: '',

    search: '',
    caseStatus: [] as any,
    hospitalId: [] as any,
    submitTimeBegin: '',
    submitTimeEnd: '',
    feedbackTimeBegin: '',
    feedbackTimeEnd: '',
    deptId: [] as any,
    labelId: [] as any,
    provinceId: '',
    cityId: '',
    countyId: '',
    isReject: '',
    isHighQuality: '',
    isOpen: '',
    needDeal: '',
    newFeedback: '',
    orderType: 'feedbackTime',

    myCaseCount: 0,

    userInfo: {},

    entryDetail: false,
  },
  onLoad() {},
  onShow() {
    this.getTabBar().setData({
      active: 2,
      showEntryCase: false,
      notice: false,
    });
    if (this.data.entryDetail) {
      this.setData({
        entryDetail: false,
      });
      return;
    }
    this.handleNav({
      currentTarget: {
        dataset: {
          nav: app.globalData.caseNav,
          noSearch: true,
        },
      },
    });
    this.setData({
      caseStatus: app.globalData.caseStatus ? app.globalData.caseStatus.split(',') : '',
      caseStatusName: app.globalData.caseStatusName,
      newFeedback: app.globalData.newFeedback,
    });
    app.globalData.caseNav = '0';
    app.globalData.caseStatus = '';
    app.globalData.caseStatusName = '全部';
    app.globalData.newFeedback = '';
    this.setData({
      needDeal: app.globalData.needDeal,
    });
    app.globalData.needDeal = '';
    app.waitLogin().then(() => {
      app.mpBehavior({ PageName: 'PG_CASELIST' });
      this.getBaseInfo();
      this.getList();
      this.getHospitalsList();
      this.getHostipalDict();
      this.getDoctorDict();
      this.getArea();
      app.getUserInfo(this, (userInfo) => {
        this.getTabBar().setData({
          userInfo,
        });
      });
      this.getNotice();
    });
  },
  getNotice() {
    wx.ajax({
      method: 'GET',
      url: '?r=takeda/doctor/todo',
      data: {},
    }).then((res) => {
      this.getTabBar().setData({
        notice: res.notReadChatRoomCount > 0,
      });
    });
  },
  getBaseInfo() {
    wx.ajax({
      method: 'GET',
      url: '?r=takeda/case/get-base-info',
      data: {},
    }).then((res) => {
      this.setData({
        caseStatusList: res.caseStatusList,
        fileTypeList: res.fileTypeList,
        reasonList: res.reasonList,
      });
    });
  },
  getArea() {
    wx.ajax({
      method: 'GET',
      url: '/js/area.json',
      isJSON: true,
    }).then((res) => {
      this.setData({
        area: res,
      });
    });
  },
  handleNav(e) {
    const { nav, noSearch } = e.currentTarget.dataset;
    this.setData({
      nav,
      isOpen: nav === '1' ? '1' : '',
      isHighQuality: nav === '2' ? '1' : '',
      isReject: '',
    });
    if (noSearch) return;
    this.handleSearch();
  },
  getList(newPage = 1) {
    wx.ajax({
      method: 'POST',
      url: `?r=takeda/case/get-list&type=${Number(this.data.nav) + 1}&page=${newPage}`,
      data: {
        search: this.data.search,
        caseStatus: this.data.caseStatus,
        submitTimeBegin: this.data.submitTimeBegin,
        submitTimeEnd: this.data.submitTimeEnd,
        feedbackTimeBegin: this.data.feedbackTimeBegin,
        feedbackTimeEnd: this.data.feedbackTimeEnd,
        deptId: this.data.deptId,
        labelId: this.data.labelId,
        provinceId: this.data.provinceId,
        cityId: this.data.cityId,
        countyId: this.data.countyId,
        hospitalId: this.data.hospitalId,
        isReject: this.data.isReject,
        isHighQuality: this.data.isHighQuality,
        isOpen: this.data.isOpen,
        needDeal: this.data.needDeal,
        newFeedback: this.data.newFeedback,
        orderType: this.data.orderType,
      },
    }).then((res) => {
      const list = res.page === 1 ? res.list : [...this.data.list, ...res.list];
      this.setData({
        myCaseCount: res.myCaseCount,
        list,
        pagination: {
          page: res.page,
          pages: res.pages,
          count: res.count,
        },
      });
    });
  },
  onReachBottom() {
    const { page, pages } = this.data.pagination;
    if (pages > page && this.data.list.length) {
      this.getList(page + 1);
    }
  },
  handleSearchFocus() {
    app.mpBehavior({ PageName: 'BTN_CASELISTSEARCH' });
  },
  handleSearch() {
    this.getList();
  },
  handleCaseShow() {
    this.setData({
      show1: true,
    });
  },
  handleCancel(e) {
    const { key } = e.currentTarget.dataset;
    this.setData({
      [key]: '',
    });
    this.handleSearch();
  },
  handleCase(e) {
    const { value } = e.currentTarget.dataset;
    const { caseStatus, caseStatusList } = this.data;
    if (!value) {
      this.setData({
        caseStatus: [],
        caseStatusName: '全部',
      });
      return;
    }
    if (caseStatus.includes(value)) {
      this.setData({
        caseStatus: caseStatus.filter((item) => item !== value),
        caseStatusName:
          caseStatus
            .filter((item) => item !== value)
            .map((item) => caseStatusList[item])
            .join(',') || '全部',
      });
    } else {
      this.setData({
        caseStatus: [...caseStatus, value],
        caseStatusName: [...caseStatus, value].map((item) => caseStatusList[item]).join(',') || '全部',
      });
    }
  },
  handleCaseSubmit() {
    this.setData({
      show1: false,
    });
    this.handleSearch();
  },
  onClose() {
    const { show2, show3, showArea } = this.data;
    this.setData({
      show1: false,
      show2: false,
      show3: false,
      showArea: false,
    });
    if (show2) {
      this.setData({
        hospitalId: '',
        hospitalName: '全部',
      });
      this.handleSearch();
    }
    if (showArea) {
      this.setData({
        provinceId: '',
        cityId: '',
        countyId: '',
        provinceName: '',
        cityName: '',
        countyName: '',
      });
      this.handleSearch();
    }
    if (show3) {
      this.setData({
        deptId: [],
        labelId: [],
        deptName: '全部',
        labelName: '全部',
      });
      this.handleSearch();
    }
  },
  handleImagePreview(e) {
    const { index, parent } = e.currentTarget.dataset;
    const sources = parent.map((item) => {
      return {
        url: item.fileType == 3 ? item.videoUrl : item.url,
        type: item.fileType == 3 ? 'video' : 'image',
      };
    });
    wx.previewMedia({
      sources,
      current: index,
    });
  },
  handleDetail(e) {
    const { params } = e.currentTarget.dataset;
    app.mpBehavior({ PageName: 'BTN_CASECARD' });
    this.setData({
      entryDetail: true,
    });
    wx.navigateTo({
      url: `/module1/pages/casesDetail/index?id=${params.caseId}`,
    });
  },

  // 医院选择弹窗
  handleHostipalShow() {
    this.setData({
      show2: true,
    });
  },
  getHostipalDict() {
    wx.ajax({
      method: 'GET',
      url: '?r=takeda/reg/hospital-dict',
      data: {},
    }).then((res) => {
      this.setData({
        hospitalClassification: res.hospitalClassification,
        hospitalLevel: res.hospitalLevel,
      });
    });
  },
  handleSearchHostipal() {
    this.getHospitalsList();
  },
  getHospitalsList(newPage = 1) {
    wx.ajax({
      method: 'GET',
      url: '?r=takeda/reg/hospitals',
      data: {
        page: newPage,
        Search: this.data.hostilatSearch,
      },
    }).then((res) => {
      const hostipalList = res.page === 1 ? res.list : [...this.data.hostipalList, ...res.list];
      this.setData({
        hostipalList,
        hostipalPagination: {
          page: res.page,
          pages: res.pages,
          count: res.count,
        },
      });
    });
  },
  handleHostipalBottom(e) {
    const hostipalPagination = this.data.hostipalPagination;
    if (e.detail.direction === 'botttom' && hostipalPagination.page < hostipalPagination.pages) {
      this.getHospitalsList(Number(hostipalPagination.page) + 1);
    }
  },
  handleHostipal(e) {
    const { params } = e.currentTarget.dataset;
    this.setData({
      show2: false,
      hospitalId: this.data.hospitalId.includes(params.HospitalId) ? [] : [params.HospitalId],
      hospitalName: this.data.hospitalId.includes(params.HospitalId) ? '全部' : params.Name,
    });
    this.handleSearch();
  },

  getDoctorDict() {
    wx.ajax({
      method: 'GET',
      url: '?r=takeda/reg/doctor-dict',
      data: {},
    }).then((res) => {
      this.setData({
        deptList: res.DoctorSpecialtyLabel,
      });
    });
  },
  handleTagShow() {
    this.setData({
      show3: true,
    });
  },
  handleDept(e) {
    const { params } = e.currentTarget.dataset;
    const deptId = this.data.deptId;
    const newDeptId: any = deptId.includes(params.value)
      ? deptId.filter((item) => item !== params.value)
      : [...deptId, params.value];
    const newDeptName = this.data.deptList
      .filter((item) => newDeptId.includes(item.value))
      .map((item) => item.label)
      .join(',');
    const labelList = this.data.deptList
      .filter((item) => newDeptId.includes(item.value))
      .reduce((pre, cur) => {
        return [...pre, ...cur.options];
      }, []);
    this.setData({
      deptId: newDeptId,
      deptName: newDeptName || '全部',
      labelList,
      labelId: [],
      labelName: '全部',
    });
  },
  handleLabel(e) {
    const { params } = e.currentTarget.dataset;
    const { labelId, labelList } = this.data;
    const newLabelId = labelId.includes(params.value)
      ? labelId.filter((item) => item !== params.value)
      : [...labelId, params.value];
    let labelName = '';
    labelList.forEach((item) => {
      if (newLabelId.includes(item.value)) {
        labelName = `${labelName}${labelName ? ',' : ''}${item.label}`;
      }
    });

    this.setData({
      labelId: newLabelId,
      labelName: labelName || '全部',
    });
  },
  handleTagSubmit() {
    const { deptId, labelId } = this.data;
    if (deptId.length && !labelId.length) {
      wx.showToast({
        title: '请选择标签',
        icon: 'none',
      });
      return;
    }
    this.setData({
      show3: false,
    });
    this.handleSearch();
  },

  handleArea() {
    this.setData({
      showArea: true,
    });
  },
  onFinish(e: any) {
    this.setData({
      provinceId: e.detail.code[0],
      provinceName: e.detail.value[0],
      cityId: e.detail.code[1],
      cityName: e.detail.value[1],
      countyId: e.detail.code[2],
      countyName: e.detail.value[2],
      showArea: false,
    });
    this.handleSearch();
  },

  handleRadio(e) {
    const { key } = e.currentTarget.dataset;
    const PageName = {
      isReject: 'BTN_CASELISTREJECTFILTER',
      isHighQuality: 'BTN_CASELISTQUALITYFILTER',
      isOpen: 'BTN_CASELISTPUBLIC',
      newFeedback: 'BTN_CASELISTUPDATE',
    }[key];
    if (PageName) {
      app.mpBehavior({ PageName });
    }
    this.setData({
      [key]: this.data[key] === '1' ? '' : '1',
    });
    this.handleSearch();
  },
  handleOrder(e) {
    const { value } = e.currentTarget.dataset;
    this.setData({
      orderType: value,
    });
    this.handleSearch();
  },
  handleFold() {
    app.mpBehavior({ PageName: 'BTN_CASELISTFILTERTOGGLE' });
    this.setData({
      fold: !this.data.fold,
    });
  },
  handleDel(e) {
    const { index } = e.currentTarget.dataset;
    const params: any = this.data.list[index];
    wx.showModal({
      confirmColor: '#00B4C5',
      cancelColor: '#141515',
      title: '确认删除该病历?',
      success: (e) => {
        if (e.confirm) {
          wx.ajax({
            method: 'POST',
            url: '?r=takeda/case/delete-case',
            data: {
              caseId: params.caseId,
            },
          }).then(() => {
            this.setData({
              list: this.data.list.filter((item: any) => item.caseId !== params.caseId),
            });
          });
        }
      },
    });
  },

  handleQuestion(e) {
    const { index } = e.currentTarget.dataset;
    const message = {
      1: '设为公开的病历，公开病历平台所有医生均可访问',
      2: '标为优质的病历，病历所在科室医生均可访问',
      3: '属于您所在科室的所有病历',
    }[index];
    wx.showModal({
      confirmColor: '#00B4C5',
      showCancel: false,
      confirmText: '知道了',
      content: message,
    });
  },

  handleCatch() {
    return false;
  },
});

export {};
