const app = getApp<IAppOption>();
export {};

Page({
  data: {
    level: 0,

    hide: true,

    show1: false,
    bindDoctorName: "",

    userInfo: {},
    DoctorTitleType: {},

    hospitalClassification: {},
    hospitalLevel: {},
  },
  onShow() {
    this.setData({
      hide: false,
    });
    this.getTabBar().setData({
      active: 1,
      showEntryCase: false,
      notice: false,
    });
    app.waitLogin().then(() => {
      app.mpBehavior({ PageName: "PG_HOME" });
      this.handleBindDoctor();
      this.getDoctorDict();
      this.getHostipalDict();
      app.getUserInfo(this, (userInfo) => {
        const level = userInfo.IsSuper === 1 ? 4 : userInfo.DoctorLevel;
        this.setData({
          level,
        });
        this.getTabBar().setData({
          userInfo,
        });
      });
      this.getNotice();
    });
  },
  onHide() {
    this.setData({
      hide: true,
    });
  },
  getNotice() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/doctor/todo",
      data: {},
    }).then((res) => {
      this.getTabBar().setData({
        notice: res.notReadChatRoomCount > 0,
      });
    });
  },
  handleBindDoctor() {
    const scene = app.globalData.scene;
    if (scene?.doctorId) {
      wx.ajax({
        method: "POST",
        url: "?r=takeda/account/bind-doctor",
        data: {
          inviteDoctorId: scene.doctorId,
        },
      }).then((res) => {
        if (res.Name) {
          this.setData({
            show1: true,
            bindDoctorName: res.Name,
          });
        }
        app.globalData.scene = null;
      });
    }
  },
  getDoctorDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/doctor-dict",
      data: {},
    }).then((res) => {
      this.setData({
        DoctorTitleType: res.DoctorTitleType,
      });
    });
  },
  getHostipalDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/hospital-dict",
      data: {},
    }).then((res) => {
      this.setData({
        hospitalClassification: res.hospitalClassification,
        hospitalLevel: res.hospitalLevel,
      });
    });
  },
  handleSure() {
    this.setData({
      show1: false,
    });
  },

  handleQuestion(e) {
    const index = e.detail;
    const tip = {
      1: "无任何医生反馈、以及操作的病历",
      2: "有医生反馈且未归档的病历",
      3: "设为归档的病历，病历参与者不可反馈，仅可访问",
      4: "科室医生入驻情况：按月统计所在科室注册平台的医生数，并以堆叠图显示一级医生、二级医生、三级医生数;其中，一级医生为全平台的一级医生，不区分科室",
      5: "累计病历统计：按月统计所在科室累计提交的病历数，并以堆叠图显示一级医生、核心医生提交病历数",
      6: "科室新增病历统计：按月统计所在科室新提交的病历 数，并以堆叠图显示一级医生、核心医生提交的病历数",
      7: "医院活跃排行榜：按医院入驻医生数进行活跃排序，入驻医生数越多则活跃度越高，排序则越靠前",
      8: "s1：一级医生",
      9: "S2：核心医生",
      10: "S3：质控医生",
    }[index];
    const PageName = {
      1: "BTN_MANAGEDCASESNEWINFO",
      2: "BTN_MANAGEDCASESDISCUSSINFO",
      3: "BTN_MANAGEDCASESCLOSEDINFO",
    }[index];
    if (PageName) {
      app.mpBehavior({ PageName });
    }
    wx.showModal({
      content: tip,
      confirmColor: "#00B4C5",
      cancelColor: "#141515",
      showCancel: false,
    });
  },
});
