const app = getApp<IAppOption>();

Page({
  data: {
    userInfo: {},
    DoctorTitleType: {},
  },
  onLoad() {},
  onShow() {
    this.getTabBar().setData({
      active: 4,
      showEntryCase: false,
      notice: false,
    });
    app.waitLogin().then(() => {
      app.mpBehavior({ PageName: "PG_MY" });
      this.getDoctorDict();
      app.getUserInfo(this, (userInfo) => {
        this.getTabBar().setData({
          userInfo,
        });
      });
      this.getNotice();
    });
  },
  getNotice() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/doctor/todo",
      data: {},
    }).then((res) => {
      this.getTabBar().setData({
        notice: res.notReadChatRoomCount > 0,
      });
    });
  },
  getDoctorDict() {
    wx.ajax({
      method: "GET",
      url: "?r=takeda/reg/doctor-dict",
      data: {},
    }).then((res) => {
      this.setData({
        DoctorTitleType: res.DoctorTitleType,
      });
    });
  },
  handleUserInfo() {
    app.mpBehavior({ PageName: "BTN_MYPERSONALINFO" });
    wx.navigateTo({
      url: "/module1/pages/userInfo/index",
    });
  },
  handleProtocol() {
    app.mpBehavior({ PageName: "BTN_MYPRIVACYPOLICY" });
    wx.navigateTo({
      url: "/module1/pages/loginProtool/index?ismy=1",
    });
  },
  handleInvite() {
    app.mpBehavior({ PageName: "BTN_MYQRCODEPOSTER" });
    wx.navigateTo({
      url: "/module1/pages/invite/index",
    });
  },
  handleHelp() {
    app.mpBehavior({ PageName: "BTN_MYHELPMANUAL" });
    wx.navigateTo({
      url: "/module1/pages/help/index",
    });
  },
});

export {};
